// ==UserScript==
// @name           My Brute Ad Sweeper
// @description    Removes advertising from My Brute sites mybrute.com, elbruto.es and labrute.fr
// @version        0.3.2
// @include        http://*.mybrute.com/*
// @include        http://*.elbruto.es/*
// @include        http://*.labrute.fr/*
// ==/UserScript==

/* ChangeLog
  0.3.2 - Mar 22, 2010
  - New: Google Chrome compatibility.
  - Fix: Remove specific elements instead of first-child on the cellule page (thanks sioc)

  0.3.1 - Dec 10, 2009
  - New: Remove header clutter.
  - Fix: Avoid null element on 'what fight?' page.

  0.3.0 - Dec 7, 2009
  - New: Option to remove text and image clutter in addition to the ads.
  - Fix: Adjust page when watching a recorded fight.

  0.2.0 - Dec 5, 2009
  - New: Remove ads from fight page.
  - New: Navigation aid: Option to show links as soon as the fight page is loaded.
  - New: Remove xmas ads from cellule page.
*/

// Settings
var showLinks     = true;
var removeClutter = true;

// Initialization
var adClasses = ['cellulePub', 'teamPub', 'pub', 'btn-iphone', 'btn-tshirt'];
var page      = /^\/(\w*)/.exec(location.pathname)[1];

// Main logic
removeAllAds();
removeAllClutter();

// Core Functions
function removeAllAds() {
  each(adClasses, removeByClass);
  adjustFightPage();
}

function adjustFightPage() {
  if(!onFightPage()) return;
  var element = document.getElementById('debrief');
  if(!element) return;
  element.style.marginLeft = "244px";
  if(showLinks) element.style.display = "block";
  element = document.getElementById('swf_client');
  element.style.marginLeft = "244px";
}

function removeAllClutter() {
  if(!removeClutter) return;
  removeBySelector(".url, #headArtworkLeft, #headArtworkRight");
  removePageClutter();
}

function removePageClutter () {
  var selectors = {
    "cellule": "div.caracs>p, div.objects>div:not([id])",
    "arene"  : ".caracs>.center>img, .areneRight>div:not([id]), .areneRight>img" }
  selector = selectors[page];
  if(selector) removeBySelector(selector);
}

// Helpers
function removeNode(node) { node.parentNode.removeChild(node); }
function removeByClass(cssClass) { each(document.getElementsByClassName(cssClass), removeNode); }
function removeBySelector(cssSelector) { each(document.querySelectorAll(cssSelector), removeNode); }
function onFightPage() { return page == 'fight' || page == 'tf' }
function each(list, func) { for (var i = 0, e; e = list[i]; i++) { func(e); } }